using System;
using System.Collections;
using System.Text;
using System.IO;
using Keyoti.SearchEngine.Events;
using Keyoti.SearchEngine.Documents;
using Keyoti.SearchEngine.DataAccess;
using Keyoti.SearchEngine;

namespace Keyoti.SearchEngine
{


    public class ExternalEventHandler
    {
        IEventDispatcher dispatcher;
        Configuration conf;
        public ExternalEventHandler(IEventDispatcher dispatcher, Configuration conf)
        {
            Keyoti.SearchEngine.DataAccess.Log.WriteLogEntry("Plug-in", "Initialized", conf);
            dispatcher.Action += new ActionEventHandler(dispatcher_Action);
            dispatcher.NeedObject += new NeedObjectEventHandler(dispatcher_NeedObject);
            this.dispatcher = dispatcher;
            this.conf = conf;

            
        }


        public void DetachHandlers()
        {
            if (dispatcher != null)
            {
                dispatcher.Action -= new ActionEventHandler(dispatcher_Action);
                dispatcher.NeedObject -= new NeedObjectEventHandler(dispatcher_NeedObject);
            }
            

        }


        public void dispatcher_Action(object sender, ActionEventArgs e)
        {
            
        }

        public void dispatcher_NeedObject(object sender, NeedObjectEventArgs e)
        {
            if (e.RequiredObject is ParserProvider)
            {
                Keyoti.SearchEngine.DataAccess.Log.WriteLogEntry("Plug-in", "Created extended provider", conf);
                e.RequiredObject = new Plugin.ExtendedParserProvider(conf);
            }

        }
    }
}
